

//////////////////////////////////////////////////////////////////////////////
//
//

#define FAR		_far

typedef unsigned int	WORD;
typedef long		LONG;
typedef unsigned long	DWORD;
typedef unsigned char	BYTE;
typedef char FAR *	LPSTR;
typedef char *		NPSTR;
typedef void		VOID;

#define MAKEWORD(a, b)	    ((WORD)(((BYTE)(a)) | ((WORD)((BYTE)(b))) << 8))
#define LOBYTE(w)	    ((BYTE)(w))
#define HIBYTE(w)	    ((BYTE)(((WORD)(w) >> 8) & 0xFF))


//////////////////////////////////////////////////////////////////////////////
//				  Const define
//
//
#define TRUE				1
#define FALSE				0

#define RB_SIZE 			288
#define CB_SIZE 			596
#define CV_SIZE 			2046

#define CHANNEL_LINE			2
#define CHANNEL_EXTMIC			8
#define CHANNEL_SPEAKER 		16

#define DF_CELP 			1
#define DF_ADPCM2BIT			2
#define DF_ADPCM3BIT			3
#define DF_ADPCM3BITNEW 		30
#define DF_ADPCM4BIT			4


//////////////////////////////////////////////////////////////////////////////
// Struct Define
//
//
typedef struct _tagZVAPIFILECONV
{
   char cbRcnt;
   char cbCompBit;

   int nRdata;
   int nEstMax;
   int nDelta;
   int nBlkCnt;
   int nData;
   int nPack;

   int nMaxTbl[4];
}ZVAPIFILECONV;

typedef struct _tagZVAPITOADPCMRESULT
{
   char szAdpcmData[10];
   int nDataByte;
}ZVAPITOADPCMRESULT;

typedef struct _tagZVRIFF
{
      char szRiff[4];		// "RIFF"
      DWORD dwFileLen;		// File length - 8
      char szWave[8];		// "WAVEfmt "

      DWORD dwFmtCategory;	// 0x00000010
      WORD wFmtTag;		// 0x0001 for PCM
      WORD wChannel;		// 0x0001 for mono
      DWORD dwSampPerSec;	// double word data
      DWORD dwAvgBytePerSec;	// double word data

      WORD wBlkAlign;		// 4 - 16bits / sterio
				// 2 - 16bits / mono
				// 2 - 8bits / sterio
				// 1 - 8bit / mono
      WORD wBitsPerSamp;	// 8 / 16

      char szData[4];		// "data"
      DWORD dwDataLen;		// Wave Data Block size in byte
}ZVRIFF;

typedef struct _tagZVINTERPOLATIONRESULT
{
   char szPCMData[100]; 	// The PCM code result after interpolation
   int nPCMDataPtr;		// The result code byte number
}ZVINTERPOLATIONRESULT;
typedef ZVINTERPOLATIONRESULT ZVDECIMATIONRESULT;

typedef struct _tagZVINTERPOLATIONPARAM
{
   float To;		// 1/OutSampleRate
   float Ti;		// 1/InSampleRate
   float Tnow;		// Time reference value
}ZVINTERPOLATIONPARAM;
typedef ZVINTERPOLATIONPARAM ZVDECIMATIONPARAM;



//////////////////////////////////////////////////////////////////////////////
// Function
//
int ConvertAdpcm_to_Wave8m(
char * npszAd,
char * npszWave,
int nSampRate);

VOID InitialRIFFHeader(
ZVRIFF *npZvRiff,
int nSampRate);

VOID InitialInterPolation(
ZVINTERPOLATIONPARAM *npzvInterpPm,
ZVRIFF *npzvAdpcm,
ZVRIFF *npzvWave);

VOID InitialDecimation(
ZVINTERPOLATIONPARAM *npzvInterpPm,
ZVRIFF *npzvAdpcm,
ZVRIFF *npzvWave);

int Interpolation(
BYTE cbSpn_1,
BYTE cbSpn_2,
ZVINTERPOLATIONPARAM * npzvInterpPm,
ZVINTERPOLATIONRESULT * npzvInterpResult);

int Decimation(
BYTE cbSpn_1,
BYTE cbSpn_2,
ZVDECIMATIONPARAM *npzvDecimatPm,
ZVDECIMATIONRESULT *npzvDecimatResult);

int ConvertWave8m_to_Adpcm(
char *npszWave,
char *npszAd,
int nDf);

int checkWave8mHeader(
FILE *fWave,
ZVRIFF *npzvWave);


///////////////////////////////////////////////////////////////////////////////
// VCKERNAL.ASM Define Functions
//

void Adaptive(
BYTE cbDataBit,
LPSTR lpzf);

WORD Voc8Bit(
LPSTR lpzf);

WORD Quantize8BitWave(
BYTE cbDataBit,
WORD nEdata,
LPSTR lpzf,
LPSTR lpzfadpcm);


WORD ToVoc(
int,
LPSTR);

int ToAdpcm(
int,
LPSTR,
LPSTR);

int WriteConvertFile(
FILE *fAd,
char * npAdBuf,
int nAdBufptr);
